from typing import Tuple, Set, Iterable, List

class GH_Interpolation:
    linear = 1
    cubic = 2
class GH_Stack:
    def __init__(self): ...
    def __init__(self, update_interval : int): ...
    def __init__(self, update_interval : int, animation_length : int): ...
    def __init__(self, update_interval : int, animation_length : int, animation_interpolation : GH_Interpolation): ...
    def SetOwner (self, ui_thread_owner : Control, ui_thread_update : GH_StackEventDelegate) -> None: ...
    def SetOwner (self, ui_thread_owner : Control, ui_thread_update : GH_StackEventDelegate, ui_thread_complete : GH_StackEventDelegate) -> None: ...
    def Destroy (self) -> None: ...
    @property
    def Count (self) -> int: ...
    @property
    def InMotion (self) -> bool: ...
    @property
    def InMotion (self, index : int) -> bool: ...
    @property
    def UpdateInterval (self) -> int: ...
    @UpdateInterval.setter
    def UpdateInterval (self, Value : int) -> None: ...
    @property
    def Duration (self) -> int: ...
    @Duration.setter
    def Duration (self, Value : int) -> None: ...
    @property
    def Interpolation (self) -> GH_Interpolation: ...
    @Interpolation.setter
    def Interpolation (self, Value : GH_Interpolation) -> None: ...
    def AddElement (self, rec : Rectangle) -> None: ...
    def AddElement (self, rec_0 : Rectangle, rec_1 : Rectangle) -> None: ...
    def AddElement (self, rec_0 : Rectangle, rec_1 : Rectangle, duration_override : int) -> None: ...
    def InsertElement (self, index : int, rec : Rectangle) -> None: ...
    def InsertElement (self, index : int, rec_0 : Rectangle, rec_1 : Rectangle) -> None: ...
    def InsertElement (self, index : int, rec_0 : Rectangle, rec_1 : Rectangle, duration_override : int) -> None: ...
    def RemoveElement (self, index : int) -> None: ...
    def Clear (self) -> None: ...
    @property
    def Element_Initial (self, index : int) -> Rectangle: ...
    @property
    def Element_Final (self, index : int) -> Rectangle: ...
    @property
    def Element_Intermediate (self, index : int) -> Rectangle: ...
    def SetNewTarget (self, index : int, element : Rectangle) -> None: ...
    def SetNewTarget (self, index : int, element : Rectangle, bAnimate : bool) -> None: ...
    def ResizeContainer (self, region : Rectangle, fit_horizontal : bool, fit_vertical : bool) -> None: ...
class GH_Motion:
    def __init__(self, rec_0 : Rectangle, rec_1 : Rectangle, duration : int): ...
    def __init__(self, rec_0 : Rectangle, rec_1 : Rectangle, time_0 : Int64, time_1 : Int64): ...
    @property
    def Interpolation (self) -> GH_Interpolation: ...
    @Interpolation.setter
    def Interpolation (self, Value : GH_Interpolation) -> None: ...
    @property
    def InMotion (self) -> bool: ...
    @property
    def t0 (self) -> Int64: ...
    @property
    def t1 (self) -> Int64: ...
    @property
    def Parameter (self) -> float: ...
    @property
    def InitialBox (self) -> Rectangle: ...
    @property
    def FinalBox (self) -> Rectangle: ...
    @property
    def CurrentBox (self) -> Rectangle: ...
    def ResizeContainer (self, region : Rectangle, fit_horizontal : bool, fit_vertical : bool) -> None: ...
class GH_StackEventDelegate:
    def __init__(self, TargetObject : Object, TargetMethod : IntPtr): ...
    def BeginInvoke (self, sender : GH_Stack, DelegateCallback : AsyncCallback, DelegateAsyncState : Object) -> IAsyncResult: ...
    def EndInvoke (self, DelegateAsyncResult : IAsyncResult) -> None: ...
    def Invoke (self, sender : GH_Stack) -> None: ...
